; ================================================================
_shrinkScreen::
; ================================================================

push bc

; set width of screen in characters

ld bc,#0xbc01
out (c),c
ld bc,#0xbd00+32
out (c),c

; set horizontal position of screen so that it is centred

ld bc,#0xbc02
out (c),c
ld bc,#0xbd00+42
out (c),c

; set height of screen in CRTC characters

ld bc,#0xbc06
out (c),c
ld bc,#0xbd00+24
out (c),c

; set 8 raster lines per CRTC character line

ld bc,#0xbc09
out (c),c
ld bc,#0xbd00+7
out (c),c

; set vertical position of screen so that it is centred

ld bc,#0xbc07
out (c),c
ld bc,#0xbd00+30
out (c),c

pop bc

ret

; https://github.com/einar-saukas/ZX0/tree/main/z80
; ================================================================
_LZX0_decrunch::
; ================================================================

        di
dzx0_standard:
        ld      bc, #0xffff               ; preserve default offset 1
        push    bc
        inc     bc
        ld      a, #0x80
dzx0s_literals:
        call    dzx0s_elias             ; obtain length
        ldir                            ; copy literals
        add     a, a                    ; copy from last offset or new offset?
        jr      c, dzx0s_new_offset
        call    dzx0s_elias             ; obtain length
dzx0s_copy:
        ex      (sp), hl                ; preserve source, restore offset
        push    hl                      ; preserve offset
        add     hl, de                  ; calculate destination - offset
        ldir                            ; copy from offset
        pop     hl                      ; restore offset
        ex      (sp), hl                ; preserve offset, restore source
        add     a, a                    ; copy from literals or new offset?
        jr      nc, dzx0s_literals
dzx0s_new_offset:
        pop     bc                      ; discard last offset
        ld      c, #0xfe                  ; prepare negative offset
        call    dzx0s_elias_loop        ; obtain offset MSB
        inc     c
        ei
        ret     z                       ; check end marker
        di
        ld      b, c
        ld      c, (hl)                 ; obtain offset LSB
        inc     hl
        rr      b                       ; last offset bit becomes first length bit
        rr      c
        push    bc                      ; preserve new offset
        ld      bc, #1                   ; obtain length
        call    nc, dzx0s_elias_backtrack
        inc     bc
        jr      dzx0s_copy
dzx0s_elias:
        inc     c                       ; interlaced Elias gamma coding
dzx0s_elias_loop:
        add     a, a
        jr      nz, dzx0s_elias_skip
        ld      a, (hl)                 ; load another group of 8 bits
        inc     hl
        rla
dzx0s_elias_skip:
        ei
        ret     c
        di
dzx0s_elias_backtrack:
        add     a, a
        rl      c
        rl      b
        jr      dzx0s_elias_loop
