typedef void (*fn)();

typedef struct{
    u8* sprite;
    u16 z;
} typeZone;

typedef struct{
    typeZone* zone;
} typeLevel;

typedef struct{
    u8 tileID;
    u8 tileByte;
    u8* ptrSprite;
} typeCollideData;

// speed (upper nibble, 0 to 15): the number of frames between an urchin's movements (e.g. 2 means that the urchin will move every 2nd frame)
// delay (lower nibble): the number of frames left before the urchin moves

typedef struct{
    u8 position; // from 0 to 39, where 0 to 7 is row 0, 8 to 15 is row 1, ..., 32 to 39 is row 4
    u8 direction; // 0 = stationary, 1=up, 2=down, 3=left, 4=right
    u8 speed_delay; // speed stored in upper nibble, delay in lower nibble
} typeUrchinInstance;

typedef struct{
    u8* tblUrchin;
    typeUrchinInstance* urchinInstance;
} typeFloorUrchin;

// typedef struct{
//     // u8 text[21];
//     u8* text;
//     // u8 x;
//     // u8 y;
//     // u8 colour;
// } typeTextData;

__at(512)u8* yAddr80[84]; // 168 bytes - MUST be page-aligned

// __at(680)u8 const offset[]={ // 64 bytes
// 0,0,0,1,0,0,0,0,
// 0,1,0,0,0,1,0,0,
// 0,1,0,1,0,0,1,0,
// 1,0,1,0,1,0,1,0,
// 1,0,1,1,0,1,0,1,
// 1,1,0,1,1,1,0,1,
// 1,1,1,1,0,1,1,1,
// 1,1,1,1,1,1,1,1,
// };

__at(680)u8 offset[64];

// __at(744)u8 const hw_palette_black[16]={ // 16 bytes
// HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
// HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
// HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
// HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
// };

__at(744)u8 hw_palette_black[16];

__at(760)u8** yAddr;
__at(762) u8* vmem;
__at(764)u8* pmem;
__at(766)const u8* pTile;

__at(768)u8* yAddrC0[84]; // 168 bytes - MUST be page-aligned

// tiles that start on the left pixel of a byte

// __at(936)u8* const tblTileLocation_0[]={ // 48 bytes
// 0x8600,0x8694,0x8724,
// 0x8e00,0x8e94,0x8f24,
// 0x9600,0x9694,0x9724,
// 0x9e00,0x9e94,0x9f24,
// 0xa600,0xa694,0xa724,
// 0xae00,0xae94,0xaf24,
// 0xb600,0xb694,0xb724,
// 0xbe00,0xbe94,0xbf24,
// };

__at(936)u8* tblTileLocation_0[24]; // 48 bytes

__at(984)typeCollideData tblCollision[5]; // 20 bytes

// __at(1004)u8* const asciiChar[10]={fonts_0_bin,fonts_1_bin,fonts_2_bin,fonts_3_bin,fonts_4_bin,fonts_5_bin,fonts_6_bin,fonts_7_bin,fonts_8_bin,fonts_9_bin};
__at(1004)u8* asciiChar[10]; // 20 bytes

__at(TBL_URCHIN_0)u8 tblUrchinX[40*12]; // 480 bytes (12 tables of 40 bytes) for on-the-fly creation of floors with moving urchins

// __at(3040)u8 const hw_palette_colour[16]={ // 16 bytes
// HW_BLACK,HW_BRIGHT_WHITE,
// HW_BLUE,HW_BRIGHT_BLUE,
// HW_RED,HW_BRIGHT_RED,
// HW_GREEN,HW_BRIGHT_GREEN,
// HW_MAGENTA,HW_MAUVE,
// HW_WHITE,HW_ORANGE,
// HW_BRIGHT_YELLOW,HW_PASTEL_YELLOW,
// HW_BRIGHT_CYAN,HW_PASTEL_MAGENTA,
// };

__at(3040)u8 hw_palette_colour[16]; // 16 bytes

__at(3056)u8* vmemPlayer[8]; // 16 bytes

__at(3072)u8 spriteScratch[256];

// __at(3328)fn const tblTileFunction[16][2][3]={ // 192 bytes
// {{0,0,0},{0,0,0}},
// {{0,printTile_2x2_0,printTile_2x3_0},{0,printTile_2x2_1,printTile_2x3_1}},
// {{printTile_3x2_0,printTile_3x3_0,printTile_3x4_0},{printTile_3x2_1,printTile_3x3_1,printTile_3x4_1}},
// {{printTile_4x3_0,printTile_4x4_0,printTile_4x5_0},{printTile_4x3_1,printTile_4x4_1,printTile_4x5_1}},
// {{printTile_5x4_0,printTile_5x5_0,printTile_5x6_0},{printTile_5x4_1,printTile_5x5_1,printTile_5x6_1}},
// {{printTile_6x5_0,printTile_6x6_0,printTile_6x7_0},{printTile_6x5_1,printTile_6x6_1,printTile_6x7_1}},
// {{printTile_7x6_0,printTile_7x7_0,printTile_7x8_0},{printTile_7x6_1,printTile_7x7_1,printTile_7x8_1}},
// {{printTile_8x7_0,printTile_8x8_0,printTile_8x9_0},{printTile_8x7_1,printTile_8x8_1,printTile_8x9_1}},
// {{printTile_9x8_0,printTile_9x9_0,printTile_9x10_0},{printTile_9x8_1,printTile_9x9_1,printTile_9x10_1}},
// {{printTile_10x9_0,printTile_10x10_0,printTile_10x11_0},{printTile_10x9_1,printTile_10x10_1,printTile_10x11_1}},
// {{printTile_11x10_0,printTile_11x11_0,printTile_11x12_0},{printTile_11x10_1,printTile_11x11_1,printTile_11x12_1}},
// {{printTile_12x11_0,printTile_12x12_0,printTile_12x13_0},{printTile_12x11_1,printTile_12x12_1,printTile_12x13_1}},
// {{printTile_13x12_0,printTile_13x13_0,printTile_13x14_0},{printTile_13x12_1,printTile_13x13_1,printTile_13x14_1}},
// {{printTile_14x13_0,printTile_14x14_0,printTile_14x15_0},{printTile_14x13_1,printTile_14x14_1,printTile_14x15_1}},
// {{printTile_15x14_0,printTile_15x15_0,printTile_15x16_0},{printTile_15x14_1,printTile_15x15_1,printTile_15x16_1}},
// {{printTile_16x15_0,printTile_16x16_0,0},{printTile_16x15_1,printTile_16x16_1,0}},
// };

__at(3328)fn tblTileFunction[16][2][3]; // 192 bytes

// __at(3520)u8* const tblZoom[32]={ // 64 bytes
// 0x87b4,0x87d4,0xc7b4,0xc7d4,
// 0x8fb4,0x8fd4,0xcfb4,0xcfd4,
// 0x97b4,0x97d4,0xd7b4,0xd7d4,
// 0x9fb4,0x9fd4,0xdfb4,0xdfd4,
// 0xa7b4,0xa7d4,0xe7b4,0xe7d4,
// 0xafb4,0xafd4,0xefb4,0xefd4,
// 0xb7b4,0xb7d4,0xf7b4,0xf7d4,
// 0xbfb4,0xbfd4,0xffb4,0xffd4,
// };

__at(3520)u8* tblZoom[32]; // 64 bytes

// __at(3584)u8 const rectTop[113]={ // 113 bytes
// 35,34,34,34,33,33,33,33,32,32,32,31,31,31,30,30,
// 30,29,29,29,28,28,28,28,27,27,27,26,26,26,25,25,
// 25,24,24,24,23,23,23,23,22,22,22,21,21,21,20,20,
// 20,19,19,19,18,18,18,18,17,17,17,16,16,16,15,15,
// 15,14,14,14,13,13,13,13,12,12,12,11,11,11,10,10,
// 10,9,9,9,8,8,8,8,7,7,7,6,6,6,5,5,
// 5,4,4,4,3,3,3,3,2,2,2,1,1,1,0,0,0,
// };

__at(3584)u8 rectTop[113]; // 113 bytes

__at(3697)u8 const rectBottom[113]={ // 113 bytes
45,45,45,46,46,46,47,47,47,48,48,48,49,49,49,49,
50,50,50,51,51,51,52,52,52,53,53,53,54,54,54,54,
55,55,55,56,56,56,57,57,57,58,58,58,59,59,59,59,
60,60,60,61,61,61,62,62,62,63,63,63,64,64,64,64,
65,65,65,66,66,66,67,67,67,68,68,68,69,69,69,69,
70,70,70,71,71,71,72,72,72,73,73,73,74,74,74,74,
75,75,75,76,76,76,77,77,77,78,78,78,79,79,79,79,80,
};

__at(3810)fn const tblUrchin_small[4]={ // 10 bytes
	urchin_small_up,urchin_small_down,urchin_small_left,urchin_small_right,
};

__at(3820)fn const tblUrchin_big[4]={ // 10 bytes
	urchin_big_up,urchin_big_down,urchin_big_left,urchin_big_right,
};

// tiles that start on the right pixel of a byte
// their address is 16384 bytes after the equivalent left pixel version of the tile

__at(3830)u8* const tblTileLocation_1[]={ // 48 bytes
0xc600,0xc694,0xc724,
0xce00,0xce94,0xcf24,
0xd600,0xd694,0xd724,
0xde00,0xde94,0xdf24,
0xe600,0xe694,0xe724,
0xee00,0xee94,0xef24,
0xf600,0xf694,0xf724,
0xfe00,0xfe94,0xff24,
};

__at(3878)fn const tblCollisionFunction[24]={ // 48 bytes
sfxBlock,sfxBlock,sfxBlock,sfxBlock,sfxBlock,sfxBlock,sfxBlock,sfxBlock,
collision8,collision8,collision8,collision8,collision8,sfxBlock,sfxBlock,collision15,
collision16,collision17,collision18,collision19,collision20,collision21,collision22,collision23,
};

// level[16+1] is a placeholder for the level data that will be decrunched to 0x1000
__at(4096)typeLevel level[16+1]; // 32 bytes +2 extra to prevent problems with zoneIndex

// urchin[16+1] is a placeholder for all the urchin data that will be decrunched to 0x1000+34
__at(4130)typeFloorUrchin* urchins[16+1]; // 32 bytes +2 extra to prevent problems with zoneIndex

// typeTextData const textData[0]={
//     {"test"},
//     // {"test",0,0,2},
// };

__at(6580)const unsigned char offset_bin[22] = {
    0x8B, 0x00, 0x01, 0xFF, 0xFB, 0xF4, 0xF8, 0x7B, 0xFC, 0xE5, 0xFB, 0xFC, 0xE7, 0xF6, 0xDF, 0xF8,
    0xF4, 0x3D, 0xFE, 0xD5, 0x55, 0x60
};

__at(6602)u8 const hw_palette_black_tmp[16]={
HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
HW_BLACK,HW_BLACK,HW_BLACK,HW_BLACK,
};

__at(6618)u8* const tblTileLocation_0_tmp[24]={ // 48 bytes
0x8600,0x8694,0x8724,
0x8e00,0x8e94,0x8f24,
0x9600,0x9694,0x9724,
0x9e00,0x9e94,0x9f24,
0xa600,0xa694,0xa724,
0xae00,0xae94,0xaf24,
0xb600,0xb694,0xb724,
0xbe00,0xbe94,0xbf24,
};

__at(6666)u8* const asciiChar_tmp[10]={ // 20 bytes
fonts_0_bin,fonts_1_bin,fonts_2_bin,fonts_3_bin,fonts_4_bin,fonts_5_bin,fonts_6_bin,fonts_7_bin,fonts_8_bin,fonts_9_bin
};


__at(6686)const unsigned char player0_bin[141] = {
    0x38, 0xFF, 0x00, 0xFD, 0xA5, 0x55, 0x8A, 0xE8, 0x82, 0xAA, 0x11, 0x00, 0x27, 0x55, 0x0A, 0xE8,
    0x6B, 0x08, 0xAA, 0x10, 0x00, 0xE5, 0xEB, 0x88, 0xD1, 0x00, 0x33, 0xEB, 0xF4, 0x4C, 0x82, 0xBD,
    0x00, 0x70, 0x00, 0xDF, 0x48, 0x2A, 0xFF, 0x00, 0xAA, 0x04, 0x88, 0x06, 0xE0, 0x67, 0x9D, 0x90,
    0xAA, 0x04, 0x00, 0x9D, 0x8E, 0x55, 0x02, 0xE0, 0x2F, 0x18, 0xFD, 0xF8, 0x6D, 0x7C, 0x8F, 0x00,
    0x83, 0xDD, 0x8A, 0xFC, 0x48, 0xBA, 0x0F, 0xA0, 0xEA, 0x01, 0xE0, 0xAE, 0xAA, 0xAE, 0xAE, 0xAA,
    0x8D, 0x4A, 0xA0, 0x80, 0xF2, 0xFC, 0xAA, 0x48, 0x85, 0xE2, 0x40, 0xA0, 0xE2, 0x8C, 0xFC, 0xFF,
    0xC8, 0xE1, 0xBD, 0x61, 0xBF, 0x8C, 0x6D, 0xFC, 0xAA, 0x0D, 0xC0, 0x3E, 0x21, 0x40, 0x1F, 0xE0,
    0xD9, 0xE0, 0x6E, 0xAA, 0x85, 0x8F, 0x85, 0xF1, 0xDF, 0xE0, 0xFD, 0xF7, 0x81, 0xB5, 0x80, 0x7E,
    0xE0, 0x36, 0xAA, 0x05, 0x20, 0x2F, 0xA0, 0xC4, 0xE7, 0xFC, 0x55, 0x55, 0x80
};

__at(6827)const unsigned char player1_bin[143] = {
    0x38, 0xFF, 0x00, 0xFD, 0xA5, 0x55, 0xAA, 0xE8, 0x20, 0xAA, 0x11, 0x00, 0x27, 0x55, 0x0A, 0xE8,
    0x6B, 0x88, 0xAA, 0x50, 0x00, 0xDF, 0x92, 0x8A, 0xD5, 0x00, 0x33, 0xEB, 0x8A, 0xF4, 0x9D, 0x82,
    0xBD, 0x00, 0xE5, 0x00, 0xEB, 0x48, 0x2A, 0xFF, 0x00, 0xAA, 0x44, 0x2A, 0x06, 0xE0, 0x67, 0x9D,
    0x90, 0xAA, 0x44, 0x00, 0x6B, 0x8E, 0x55, 0x08, 0xE0, 0xAB, 0x10, 0x18, 0xFE, 0xFD, 0xED, 0x7C,
    0x23, 0x00, 0x06, 0xCA, 0xFC, 0x48, 0xBA, 0x0F, 0xA0, 0xEA, 0x04, 0xE0, 0xAE, 0xAA, 0xAE, 0xAE,
    0xAA, 0x8D, 0x4A, 0xA1, 0x80, 0xB8, 0x4C, 0xFC, 0xAA, 0x48, 0x85, 0xB8, 0x40, 0xA0, 0xB8, 0x8C,
    0xFC, 0xBF, 0xC8, 0xE1, 0xBD, 0xEF, 0x60, 0x00, 0xF9, 0xEA, 0xFC, 0x0D, 0x8F, 0xC0, 0x21, 0x87,
    0x40, 0xF6, 0xE0, 0xE0, 0x5B, 0xAA, 0xA3, 0x85, 0x85, 0xF7, 0xF1, 0xE0, 0xEB, 0xFD, 0x80, 0x88,
    0x77, 0x80, 0xE3, 0xE0, 0xAA, 0x05, 0xF7, 0xF4, 0xD5, 0xF9, 0xC4, 0xFC, 0xD5, 0x55, 0x60
};

__at(6970)const unsigned char player2_bin[146] = {
    0x38, 0xFF, 0x00, 0xFD, 0xA5, 0x55, 0x82, 0xE8, 0xA0, 0xAA, 0x11, 0x00, 0x27, 0x55, 0x0A, 0xE8,
    0x6B, 0x2A, 0xAA, 0x45, 0x00, 0xEB, 0x70, 0x8A, 0xD5, 0x00, 0x33, 0xEB, 0x8A, 0xF4, 0x6B, 0x82,
    0xBD, 0x00, 0xDF, 0x00, 0x92, 0x4E, 0xA5, 0x23, 0xAA, 0x15, 0x82, 0xBC, 0xE0, 0x67, 0x9D, 0x90,
    0xAA, 0x15, 0x00, 0x83, 0x8E, 0x55, 0x88, 0xE0, 0xAA, 0x10, 0x18, 0x98, 0x18, 0x55, 0x08, 0x22,
    0x00, 0x4C, 0x9E, 0x6B, 0x00, 0x9D, 0xFC, 0x2A, 0x48, 0xEB, 0x0F, 0xA0, 0x44, 0xAA, 0xE0, 0xAE,
    0xAA, 0xAE, 0xAE, 0xAA, 0x8D, 0x4A, 0x87, 0x80, 0xFA, 0xB9, 0xFC, 0x48, 0xAB, 0x85, 0x40, 0x8B,
    0xA0, 0x8C, 0x8B, 0xFC, 0xC8, 0xFE, 0xE1, 0xBD, 0x60, 0xFE, 0x00, 0x6D, 0xFC, 0xA8, 0x0D, 0xC0,
    0xF8, 0x21, 0x40, 0x7F, 0xE0, 0x65, 0xE0, 0xBA, 0xAA, 0x85, 0x85, 0x3F, 0xF1, 0xE0, 0x7E, 0xFD,
    0x80, 0xB7, 0x2A, 0x80, 0x7E, 0xE0, 0x36, 0xAA, 0x05, 0x20, 0x2F, 0xAA, 0xC4, 0xE7, 0xFC, 0x55,
    0x55, 0x80
};

__at(7116)const unsigned char playerRed_bin[73] = {
    0x38, 0xFF, 0x00, 0xFD, 0x88, 0x55, 0xA0, 0x3F, 0xAA, 0x50, 0x00, 0xF0, 0xF5, 0xE9, 0x9F, 0xEC,
    0xFD, 0xE7, 0xED, 0xE0, 0x9F, 0xEC, 0xFD, 0xFF, 0xD0, 0xE8, 0xF1, 0xF5, 0xBC, 0xFE, 0xE8, 0xE0,
    0x5F, 0xFD, 0xDF, 0xE0, 0xED, 0x9E, 0xF8, 0xFC, 0x5F, 0xA0, 0xF1, 0xE0, 0x7D, 0xFC, 0x78, 0x7C,
    0x1E, 0x00, 0x79, 0xCC, 0x76, 0xE0, 0x1D, 0xDF, 0x78, 0xE0, 0x7F, 0xFD, 0xF4, 0x79, 0xD0, 0xFD,
    0xCC, 0x9F, 0x20, 0xD0, 0xE7, 0xFC, 0x55, 0x55, 0x80
};

__at(7189)u8 const hw_palette_colour_tmp[16]={
HW_BLACK,HW_BRIGHT_WHITE,
HW_BLUE,HW_BRIGHT_BLUE,
HW_RED,HW_BRIGHT_RED,
HW_GREEN,HW_BRIGHT_GREEN,
HW_MAGENTA,HW_MAUVE,
HW_WHITE,HW_ORANGE,
HW_BRIGHT_YELLOW,HW_PASTEL_YELLOW,
HW_BRIGHT_CYAN,HW_PASTEL_MAGENTA,
};

// i can't recreate the sfx.bin file, as i forgot to save the instruments before generating sfx.bin!
// sfx_bin is locked into memory location 7218, thereby limiting the space I have for level design.   :(
// may as well fill the rest of the space around sfx_bin with crunched tables to relocate, in order to reduce loading time

__at(7218)const unsigned char sfx_bin[353] = {
    0x41, 0x54, 0x31, 0x30, 0x01, 0x40, 0x42, 0x0F, 0x02, 0xFF, 0x3F, 0x01, 0x60, 0x1C, 0x69, 0x1C,
    0x70, 0x1C, 0x77, 0x1C, 0x7E, 0x1C, 0x85, 0x1C, 0x8C, 0x1C, 0x93, 0x1C, 0x9A, 0x1C, 0xA1, 0x1C,
    0xB0, 0x1C, 0xC7, 0x1C, 0xDC, 0x1C, 0xE3, 0x1C, 0xF2, 0x1C, 0x1D, 0x1D, 0x26, 0x1D, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01, 0x00,
    0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20,
    0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62,
    0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62, 0x1C, 0x01,
    0x00, 0x7C, 0x01, 0x78, 0x02, 0x74, 0x03, 0x70, 0x05, 0x6C, 0x08, 0x0D, 0x62, 0x1C, 0x03, 0x00,
    0x3E, 0x16, 0x3C, 0xBC, 0x67, 0x00, 0xBC, 0x70, 0x01, 0xBC, 0x80, 0x03, 0xAC, 0x90, 0x04, 0xB8,
    0x60, 0x05, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x36, 0x0B, 0x7C, 0x16, 0x7C, 0x0C, 0x7C, 0x0A, 0x7C,
    0x08, 0x7C, 0x04, 0x78, 0x03, 0x6C, 0x01, 0x0D, 0x62, 0x1C, 0x01, 0x00, 0x02, 0x20, 0x0D, 0x62,
    0x1C, 0x01, 0x00, 0x7C, 0x08, 0x78, 0x05, 0x74, 0x03, 0x70, 0x02, 0x6C, 0x01, 0x0D, 0x62, 0x1C,
    0x02, 0x00, 0x7C, 0x02, 0x7C, 0x02, 0x7C, 0x08, 0x7C, 0x08, 0x7C, 0x08, 0x78, 0x02, 0x74, 0x02,
    0x70, 0x02, 0x6C, 0x02, 0x68, 0x03, 0x64, 0x02, 0x60, 0x03, 0x5C, 0x02, 0x58, 0x03, 0x54, 0x02,
    0x50, 0x03, 0x4C, 0x02, 0x48, 0x03, 0x44, 0x02, 0x0D, 0x62, 0x1C, 0x03, 0x00, 0x89, 0x0D, 0x89,
    0x09, 0x0D, 0x62, 0x1C, 0x03, 0x00, 0x3C, 0x38, 0x34, 0x02, 0x20, 0x3C, 0x34, 0x02, 0x20, 0xBC,
    0xE0, 0xFF, 0xBC, 0xE0, 0xFF, 0xF8, 0xE8, 0xFF, 0x01, 0xB8, 0xE0, 0xFF, 0xF4, 0xE8, 0xFF, 0x01,
    0xB4, 0xE0, 0xFF, 0xF0, 0xE8, 0xFF, 0x01, 0xB0, 0xE0, 0xFF, 0xEC, 0xE8, 0xFF, 0x01, 0xAC, 0xE0,
    0xFF, 0xE4, 0xE8, 0xFF, 0x01, 0xA4, 0xE0, 0xFF, 0xE0, 0xE8, 0xFF, 0x01, 0xA0, 0xE0, 0xFF, 0xDC,
    0xE8, 0xFF, 0x01, 0x98, 0xE0, 0xFF, 0xD4, 0xE8, 0xFF, 0x01, 0x90, 0xE0, 0xFF, 0xCC, 0xE8, 0xFF,
    0x01, 0x88, 0xE0, 0xFF, 0xC4, 0xE8, 0xFF, 0x01, 0x0D, 0x62, 0x1C, 0x40, 0x00, 0x00, 0x00, 0x8D,
    0x1D, 0x00, 0x8E, 0x1D, 0x8E, 0x1D, 0x8E, 0x1D, 0x01, 0x83, 0x1D, 0x00, 0x42, 0x80, 0x00, 0x00,
    0x00
};

__at(7571)const unsigned char player3_bin[144] = {
    0x38, 0xFF, 0x00, 0xFD, 0xA5, 0x55, 0x20, 0xE8, 0x8A, 0xAA, 0x11, 0x00, 0x27, 0x55, 0x0A, 0xE8,
    0x6B, 0x82, 0xAA, 0x55, 0x00, 0x92, 0xE5, 0x88, 0xD5, 0x00, 0x33, 0xEB, 0xF4, 0x83, 0x82, 0xBD,
    0x00, 0xEB, 0x00, 0x70, 0x48, 0x2A, 0xFF, 0x00, 0xAA, 0x41, 0x02, 0x06, 0xE0, 0x67, 0x9D, 0x90,
    0xAA, 0x41, 0x00, 0x06, 0x8E, 0x55, 0x2A, 0xE0, 0xAB, 0x10, 0x18, 0x8F, 0xFD, 0x55, 0x08, 0x7C,
    0x88, 0x00, 0x9D, 0xF8, 0xF9, 0xFC, 0xAB, 0x48, 0x0F, 0xAE, 0xA0, 0x15, 0xE0, 0xAA, 0xAE, 0xAE,
    0xAA, 0xAE, 0x8D, 0xAA, 0x4A, 0x80, 0x1B, 0x4C, 0x8A, 0xFC, 0x48, 0xAB, 0x85, 0x40, 0x8B, 0xA0,
    0x8C, 0x8B, 0xFC, 0xC8, 0xFE, 0xE1, 0xBD, 0x60, 0xFE, 0x00, 0x6D, 0xFC, 0xA8, 0x0D, 0xC0, 0xF8,
    0x21, 0x40, 0x7F, 0xE0, 0x65, 0xE0, 0xBA, 0xAA, 0x85, 0x85, 0x3F, 0xF1, 0xE0, 0x7E, 0xFD, 0x80,
    0xB7, 0x82, 0x80, 0x7E, 0xE0, 0x3F, 0xAA, 0x05, 0xF4, 0xFE, 0xD9, 0xC4, 0xFC, 0x75, 0x55, 0x58
};

__at(7715)const unsigned char player4_bin[145] = {
    0x38, 0xFF, 0x00, 0xFD, 0xA5, 0x55, 0xA0, 0xE8, 0xAA, 0xAA, 0x11, 0x00, 0x27, 0x55, 0x0A, 0xE8,
    0x6B, 0x02, 0xAA, 0x41, 0x00, 0x70, 0xDF, 0x8A, 0xD5, 0x00, 0x33, 0xEB, 0x8A, 0xF4, 0x06, 0x82,
    0xBD, 0x00, 0x92, 0x00, 0xE5, 0x48, 0x2A, 0xFF, 0x00, 0xAA, 0x01, 0x08, 0x06, 0xE0, 0x67, 0x9D,
    0x90, 0xAA, 0x01, 0x00, 0x4C, 0x8E, 0x55, 0x82, 0xE0, 0xAB, 0x10, 0x18, 0xFE, 0xFD, 0xB1, 0x7C,
    0x22, 0x00, 0x6B, 0x38, 0x00, 0x9D, 0xFC, 0xAB, 0x48, 0x0F, 0xFA, 0xA1, 0xA9, 0xE0, 0xAA, 0xAE,
    0xAE, 0xAA, 0xAE, 0x8D, 0xA8, 0x4A, 0x80, 0x6E, 0x4C, 0xFC, 0x2A, 0x48, 0xAE, 0x85, 0x40, 0xA0,
    0x2E, 0x8C, 0xFC, 0x2F, 0xC8, 0xE1, 0xFB, 0xBD, 0x61, 0xCC, 0xFA, 0x6D, 0xFC, 0x0D, 0xA3, 0xC0,
    0xE1, 0x21, 0x40, 0xFD, 0xE0, 0x96, 0xE0, 0xE8, 0xAA, 0x85, 0x85, 0xFD, 0xF1, 0xE0, 0xFA, 0xFD,
    0x80, 0xDD, 0x02, 0x80, 0xF8, 0xE0, 0xD8, 0xAA, 0x05, 0x20, 0xBF, 0x20, 0xC4, 0x9D, 0xFC, 0x55,
    0x56
};

__at(7860)fn const tblTileFunction_tmp[16][2][3]={ // 192 bytes
{{0,0,0},{0,0,0}},
{{0,printTile_2x2_0,printTile_2x3_0},{0,printTile_2x2_1,printTile_2x3_1}},
{{printTile_3x2_0,printTile_3x3_0,printTile_3x4_0},{printTile_3x2_1,printTile_3x3_1,printTile_3x4_1}},
{{printTile_4x3_0,printTile_4x4_0,printTile_4x5_0},{printTile_4x3_1,printTile_4x4_1,printTile_4x5_1}},
{{printTile_5x4_0,printTile_5x5_0,printTile_5x6_0},{printTile_5x4_1,printTile_5x5_1,printTile_5x6_1}},
{{printTile_6x5_0,printTile_6x6_0,printTile_6x7_0},{printTile_6x5_1,printTile_6x6_1,printTile_6x7_1}},
{{printTile_7x6_0,printTile_7x7_0,printTile_7x8_0},{printTile_7x6_1,printTile_7x7_1,printTile_7x8_1}},
{{printTile_8x7_0,printTile_8x8_0,printTile_8x9_0},{printTile_8x7_1,printTile_8x8_1,printTile_8x9_1}},
{{printTile_9x8_0,printTile_9x9_0,printTile_9x10_0},{printTile_9x8_1,printTile_9x9_1,printTile_9x10_1}},
{{printTile_10x9_0,printTile_10x10_0,printTile_10x11_0},{printTile_10x9_1,printTile_10x10_1,printTile_10x11_1}},
{{printTile_11x10_0,printTile_11x11_0,printTile_11x12_0},{printTile_11x10_1,printTile_11x11_1,printTile_11x12_1}},
{{printTile_12x11_0,printTile_12x12_0,printTile_12x13_0},{printTile_12x11_1,printTile_12x12_1,printTile_12x13_1}},
{{printTile_13x12_0,printTile_13x13_0,printTile_13x14_0},{printTile_13x12_1,printTile_13x13_1,printTile_13x14_1}},
{{printTile_14x13_0,printTile_14x14_0,printTile_14x15_0},{printTile_14x13_1,printTile_14x14_1,printTile_14x15_1}},
{{printTile_15x14_0,printTile_15x15_0,printTile_15x16_0},{printTile_15x14_1,printTile_15x15_1,printTile_15x16_1}},
{{printTile_16x15_0,printTile_16x16_0,0},{printTile_16x15_1,printTile_16x16_1,0}},
};

__at(8052)u8* const tblZoom_tmp[32]={ // 64 bytes
0x87b4,0x87d4,0xc7b4,0xc7d4,
0x8fb4,0x8fd4,0xcfb4,0xcfd4,
0x97b4,0x97d4,0xd7b4,0xd7d4,
0x9fb4,0x9fd4,0xdfb4,0xdfd4,
0xa7b4,0xa7d4,0xe7b4,0xe7d4,
0xafb4,0xafd4,0xefb4,0xefd4,
0xb7b4,0xb7d4,0xf7b4,0xf7d4,
0xbfb4,0xbfd4,0xffb4,0xffd4,
};

__at(8116)const unsigned char rectTop_bin[65] = {
    0x22, 0x23, 0x22, 0x9A, 0x21, 0x20, 0x28, 0x1F, 0xA2, 0x1E, 0x8A, 0x1D, 0x1C, 0x68, 0x1B, 0xA2,
    0x1A, 0x8A, 0x19, 0x18, 0x29, 0x17, 0xA2, 0x16, 0x8A, 0x15, 0x14, 0x28, 0x13, 0xA6, 0x12, 0x8A,
    0x11, 0x10, 0x28, 0x0F, 0xA2, 0x0E, 0x9A, 0x0D, 0x0C, 0x28, 0x0B, 0xA2, 0x0A, 0x8A, 0x09, 0x08,
    0x68, 0x07, 0xA2, 0x06, 0x8A, 0x05, 0x04, 0x29, 0x03, 0xA2, 0x02, 0x8A, 0x01, 0x00, 0x35, 0x55,
    0x58
};

u8 page;
u8* p;
u8* pLineTop;
u8* pLineBottom;
u8** pLineY;

u16 clsColour;
u8 clsReps;

u8 posX;
u8 posY;

u8 currentLevel;
u8 zoneIndex;

u8 objectZoom;
u16 objectDistance;

u8 lineLeft;
u8 lineRight;
u8 lineTop;
u8 lineBottom;
u8 lineWidth;
u16 rectZ;
u8 rectCount;

u8 tileHeight;
u8 baseSize;
u8 offsetRow;
u8 offsetX;
u8 offsetY;
u8* ptrSprite;

typeZone* ptrZone;
u8 zoneReps;
u8 zoneFrom;
u8 zoneTo;

typeFloorUrchin* ptrFloorUrchin;
typeUrchinInstance* ptrUrchinInstance;
u8 urchinDelay;

u8 player_x;
u8 player_y;
u16 player_z;
u8 player_z_tmp;
i8 player_moveSpeed;
i8 player_maxSpeed;

u16 player_zFrom;
u16 player_zTo;
u8 player_direction;
u8 player_frame;
u8 player_dead; // 0 = alive, 1=red, 2=player_frame 0

u8 collide_xFrom;
u8 collide_xTo;
u8 collide_yFrom;
u8 collide_yTo;
u16 collide_behind_z;
u8 collide_behind_zoneIndex;
u16 collision_tileID;

u8 tileID;
u8 tileByte;

u8* pUrchinDirection;

u8 gameState;
u16 score;
u16 highScore;
u8 energy;
u8 energyDecrementDelay;
u8 energyDecrement;
u8 firstBuildScreen;
u8 foodDisplay;
// u8 screenBuilt;
// u8 toPrintScore;
u8 i;
u8 j;
u8 z;

u8 sfxFoodPlayed;
u8 sfxAngryFacePlayed;
u8 sfxUrchinPlayed;
u8 sfxEolPlayed;

u8 musicPlay;

u8 logoX;
u8 textDone;
