#define LEVEL_BUFFER (u8*)0x1000
#define SCREEN_BUFFER (u8*)0x8000

#define ISOLATE_LEFT 0xAA
#define ISOLATE_RIGHT 0x55

#define RECT_LEFT 0x08
#define RECT_RIGHT 0x04
#define RECT_BYTE 0x0C

#define MAX_MOVE_SPEED 8
#define MAX_DIVE_SPEED 16
#define ENERGY_DECREMENT_DELAY 8
#define FOOD_DISPLAY 12

#define STATE_GAME_PLAY 1
#define STATE_GAME_COLLISION 2
#define STATE_GAME_PAUSED 3
#define STATE_GAME_OVER 4
#define STATE_GAME_LEVEL_COMPLETE 5
#define STATE_NEXT_LEVEL 6
#define STATE_DEAD 7
#define STATE_MAIN_MENU 10
#define STATE_INSTRUCTIONS 11
#define STATE_CREDITS 12

#define PLAYER_FRAME_LIMIT 4
#define PLAYER_DIRECTION_LEFT 0
#define PLAYER_DIRECTION_RIGHT 1

#define CLS_BLACK 0x0000
#define CLS_BLUE 0x0C0C

#define URCHIN_8_STATIONARY 80
#define URCHIN_8_UP 81
#define URCHIN_8_DOWN 82
#define URCHIN_8_LEFT 83
#define URCHIN_8_RIGHT 84

#define URCHIN_9_STATIONARY 90
#define URCHIN_9_UP 91
#define URCHIN_9_DOWN 92
#define URCHIN_9_LEFT 93
#define URCHIN_9_RIGHT 94

#define TBL_URCHIN_0 2560
#define TBL_URCHIN_1 2600
#define TBL_URCHIN_2 2640
#define TBL_URCHIN_3 2680
#define TBL_URCHIN_4 2720
#define TBL_URCHIN_5 2760
#define TBL_URCHIN_6 2800
#define TBL_URCHIN_7 2840
#define TBL_URCHIN_8 2880
#define TBL_URCHIN_9 2920
#define TBL_URCHIN_10 2960
#define TBL_URCHIN_11 3000

#define TILE_URCHIN 8
#define TILE_BIG_URCHIN_BEGIN 9
#define TILE_BIG_URCHIN_END 12
